<?php
namespace Teknisa\CMP\Modules\Fornecimento\Modules\ListaPreco\Controllers;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;

class Sup03000Data {

    protected $util;
    protected $crudService;
    protected $dataSourceName = "sup03000_data";
    protected $parameterBagColumns = array(
        "P_CDFILIAL",
        "P_ORDPRPI",
        "P_SISTEMA",
        "P_DTINIVALITM",
        "P_DTFINVALITM",
        "P_CDREGIAO",
        "P_CDOPERADOR",
        "P_TODOSPROD",
        "P_DTPROCESSA"
    );

    public function __construct($crudService, $util) {
        $this->crudService = $crudService;
        $this->util = $util;
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $filterCriteria = $request->getFilterCriteria();
        $filterCriteria->setDataSourceName($this->dataSourceName);
        $conditions = $filterCriteria->getConditions();
        $conditions[8]["value"] = $this->util->retornaDataProcessamento();
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $this->crudService->find($response, $newFilterCriteria);
    }
}