function SolicitacaoComprasController(ScreenService, SolicitacaoComprasService, templateManager, Parametros, General, MessageService) {

    var self = this;

    var stripeWidget;
    var stripeWidgetFilter              = [];
    var onEnterOnce                     = true;
    var habilitaAddProdSoli             = true;
    var bloqueiaEditEmSoliAuto          = null;
    var bloqueiaFiltroPorProdutoCompra  = null;
    var isJutificativaExtraObrigatoria  = null;
    var isJustificativaObrigatoria      = null;
    var habilitaComprador               = null;
    var habilitaDestino                 = null;
    var gravaDataUtiliza                = null;
    var habilitaStatus                  = null;
    var verificarPeriodicidade          = null;
    var pesquisaPorModuloProd           = null;
    var isContratoRescindido            = null;
    var hasRegiao                       = null;
    var utilizaAprovSoli                = null;

    self.setRegras = function (widget) {

        stripeWidget = widget;
        var cdFilial = getLocalVar('CDFILIAL');
        var nrorg = getLocalVar('NRORG');
        
        SolicitacaoComprasService.getRegras().then(function (callback) {
            var regras = callback.dataset.solicitacao_compras_regras[0];
            if (regras.IDBLOQALTNEC == 'N') {
                bloqueiaEditEmSoliAuto = false;
            } else {
                bloqueiaEditEmSoliAuto = true;
            } if (regras.IDUTPRODPREF == 'S') {
                bloqueiaFiltroPorProdutoCompra = false;
            } else {
                bloqueiaFiltroPorProdutoCompra = true;
            } if (regras.IDJUSSOLEXT == 'S') {
                isJutificativaExtraObrigatoria = true;
            } else {
                isJutificativaExtraObrigatoria = false;
            } if (regras.IDAUDALTSOL == 'S') {
                isJustificativaObrigatoria = true;
            } else {
                isJustificativaObrigatoria = false;
            } if (regras.IDULTCOMPSOL == 'S') {
                habilitaComprador = true;
            } else {
                habilitaComprador = false;
            } if (regras.IDULTDESTSOL == 'S') {
                habilitaDestino = true;
            } else {
                habilitaDestino = false;
            } if (regras.IDULTIDTULTI == 'S') {
                gravaDataUtiliza = true;
            } else {
                gravaDataUtiliza = false;
            } if (regras.IDBAIXSOLDFS == 'S') {
                habilitaStatus = true;
            } else {
                habilitaStatus = false;
            } if (regras.IDPERISOLMANUAL == 'S') {
                verificarPeriodicidade = true;
            } else {
                verificarPeriodicidade = false;
            } if (regras.IDUTMODPRODFIL == 'S') {
                pesquisaPorModuloProd = true;
            } else {
                pesquisaPorModuloProd = false;
            } if(regras.IDUTAPROVSOL == 'S'){
                utilizaAprovSoli = true;
            } else{
                utilizaAprovSoli = false;
            }

            self.controlaFieldSolicitacao(widget, utilizaAprovSoli);
            self.setVisibleFilterFields(widget.container.getWidget('cmp03100_solicitacao_FILTER'));

            SolicitacaoComprasService.getFilialData(cdFilial, nrorg).then(function (callback) {
                if (callback.dataset.filial) {
                    var filialData = callback.dataset.filial[0];
                    if (filialData.IDCNTRRESC == 'S') {
                        isContratoRescindido = true;
                    } else {
                        isContratoRescindido = false;
                    } if (filialData.CDREGIAO !== null) {
                        hasRegiao = true;
                    } else {
                        hasRegiao = false;
                    }
                }
            });
        });
    };
    self.reloadSolicitacaoOnEnter = function (widget) {
        if (onEnterOnce) {
            onEnterOnce = false;
        } else {
            widget.reload();
        }
    };

    //EXCLUIR MÉTODO APÓS ATUALIZAÇÃO DO BOWER.
    self.controlaFieldSolicitacao = function (widget, param){
        var widgetSolicita = widget.container.getWidget('cmp03100_solicitacao');

        if(param){
            widgetSolicita.getField('IDSOLIAPROV').isVisible = true;
        } else {
            widgetSolicita.getField('IDSOLIAPROV').isVisible = false;
        }
    };

    self.controlaSoliAprov = function(field){
        if(utilizaAprovSoli){
            if(field == 'S'){
                return true;
            } else{
                return false;
            }
        } else{
            return false;
        }
    };

    self.controlaSoliReprov = function(field){
        if(utilizaAprovSoli){
            if(field != 'S'){
                return true;
            } else{
                return false;
            }
        } else{
            return false;
        }
    };

    self.openFilter = function(widget) {
        var stripeWidget = widget.container.getWidget(widget.name + '_FILTER');
        if (!stripeWidget.currentRow.START) {
            stripeWidget.newRow();
        }
        ScreenService.openPopup(widget);
    };

    self.filter = function (filterWidget) {
        if(filterWidget.isValid()) {
            stripeWidget = filterWidget.getParent().container.getWidget('cmp03100_stripe');
            var parentWidget = filterWidget.getParent();
            var filterCurrentRow = filterWidget.currentRow;
            var compradorField = filterWidget.getField('COMPRADOR');
            var destinoField = filterWidget.getField('DESTINO');
            var operadorField = filterWidget.getField('OPERADOR');
            var dataInicial = filterCurrentRow.START ? moment(filterCurrentRow.START, 'DD/MM/YYYY')._d : null;
            var dataFinal = filterCurrentRow.END ? moment(filterCurrentRow.END, 'DD/MM/YYYY')._d : null;

            if (dataInicial && dataFinal && dataFinal < dataInicial) {
                MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
                return false;
            }

            stripeDataSourceFilter = [];

            stripeWidget.getField('DTPROGENTR').setValue("");

            stripeDataSourceFilter.push(
                {
                    "name": "DTPROGENTR",
                    "value": [filterWidget.currentRow.START, filterWidget.currentRow.END],
                    "operator": "BETWEEN"
                }
            );

            if (compradorField.value() !== "" && compradorField.isVisible) {
                stripeDataSourceFilter.push(
                    {
                        "name": "CDCOMPRADOR",
                        "value": filterCurrentRow.CDCOMPRADOR,
                        "operator": "="
                    }
                );
            }

            if (destinoField.value() !== "" && destinoField.isVisible) {
                stripeDataSourceFilter.push(
                    {
                        "name": "CDDESTSOLI",
                        "value": filterCurrentRow.CDDESTSOLI,
                        "operator": "="
                    }
                );
            }

            if (operadorField.value() !== "") {
                stripeDataSourceFilter.push(
                    {
                        "name": "CDOPERLANC",
                        "value": filterCurrentRow.OPERADOR,
                        "operator": "IN"
                    }
                );
            }

            stripeWidgetFilter = angular.copy(stripeDataSourceFilter);
            stripeWidget.dataSourceFilter = stripeDataSourceFilter;
            stripeWidget.reload().then(function () {
                var dados = stripeWidget.dataSource.data;

                if (dados.length > 0) {
                    var todasDatas = [];
                    var dadosFiltrados = [];

                    for (i = 0; i < dados.length; i++) {
                        todasDatas.push(dados[i].DTPROGENTR.substring(0, 10));
                    }
                    var distinctDatas = todasDatas.filter(self.getUnique);

                    for (i = 0; i < distinctDatas.length; i++) {
                        dadosFiltrados.push({"DTPROGENTR": distinctDatas[i]});
                    }

                    stripeWidget.dataSource.data = dadosFiltrados;
                    stripeWidget.moveToFirst();
                    self.setStripeValues(stripeWidget);
                }
                else {
                    self.setStripeValues(stripeWidget);
                    self.stripeNavigation(stripeWidget, parentWidget);
                }
            });
            ScreenService.closePopup();
            parentWidget.activate();
        }
    };
    self.filterProds = function (filterWidget) {
        if (filterWidget.isValid()) {
            var filterCurrentRow        = filterWidget.currentRow;
            var parentDataSourceName    = filterWidget.getParent().dataSource.name;
            var parentDataSourceFilter  = [];

            if(pesquisaPorModuloProd){
                parentDataSourceName = "/produtos_modulados";
            }
            else {
                parentDataSourceName = "/produtos_ordenados";
            }

            if (filterWidget.getField('PRODINI').value() !== "" && filterWidget.getField('PRODFIN').value() !== "") {
                for (i = filterCurrentRow.CDARVPRODFIN.length; i <= 20; i++) {
                    filterCurrentRow.CDARVPRODFIN += "Z";
                }
                parentDataSourceFilter.push(
                    {
                        "name": "CDARVPROD",
                        "value": [filterCurrentRow.CDARVPRODINI, filterCurrentRow.CDARVPRODFIN],
                        "operator": "BETWEEN"
                    }
                );
            } else {
                if (filterWidget.getField('PRODINI').value() !== "") {
                    parentDataSourceFilter.push(
                        {
                            "name": "CDARVPROD",
                            "value": filterCurrentRow.CDARVPRODINI,
                            "operator": ">="
                        }
                    );
                }
                if (filterWidget.getField('PRODFIN').value() !== "") {
                    for (i = filterCurrentRow.CDARVPRODFIN.length; i <= 20; i++) {
                        filterCurrentRow.CDARVPRODFIN += "Z";
                    }
                    parentDataSourceFilter.push(
                        {
                            "name": "CDARVPROD",
                            "value": filterCurrentRow.CDARVPRODFIN,
                            "operator": "<="
                        }
                    );
                }
            }

            if (filterCurrentRow.NRSOLICITA !== "" && filterCurrentRow.NRSOLICITA && habilitaAddProdSoli) {
                parentDataSourceName += "_por_solicitacao";
                parentDataSourceFilter.push(
                    {"name": "NRSOLI",      "operator": "=",    "value": filterCurrentRow.NRSOLICITA},
                    {"name": "CDFILSOLI",   "operator": "=",    "value": filterCurrentRow.CDFILSOLI},
                    {"name": "CDFILLAN",    "operator": "=",    "value": filterCurrentRow.CDFILLAN}
                );
                filterWidget.getParent().getField('DTPROGENTR').isVisible = true;
            } else {
                filterWidget.getParent().getField('DTPROGENTR').isVisible = false;
            }

            parentDataSourceFilter.push(
                {"name": "PRODCMP", "operator": "=", "value": filterCurrentRow.IDPRODCOMPRA}
            );
            
            filterWidget.getParent().dataSource.name = parentDataSourceName;
            filterWidget.getParent().dataSourceFilter = parentDataSourceFilter;
            filterWidget.getParent().reload();
            
            ScreenService.closePopup();
            filterWidget.getParent().activate();

        } else {
            MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
        }
    };
    self.setVisibleFilterFields = function (filterWidget) {
        
        if (habilitaComprador) {
            filterWidget.getField('COMPRADOR').isVisible = true;
        } else {
            filterWidget.getField('COMPRADOR').isVisible = false;
        }

        if (habilitaDestino) {
            filterWidget.getField('DESTINO').isVisible = true;
        } else {
            filterWidget.getField('DESTINO').isVisible = false;
        }

        filterWidget.getField('TOPERADOR').checked = true;
        General.toggleReadOnlySelect(filterWidget.getField('TOPERADOR'),filterWidget.getField('OPERADOR'));

    };
    self.setVisibleFilterProdsFields = function (filterWidget) {
        filterWidget.applyDefaultValue();
        if (habilitaAddProdSoli) {
            filterWidget.getField('NMFILIAL').isVisible = true;
            filterWidget.getField('NRSOLICITA').isVisible = true;
        } else {
            filterWidget.getField('NMFILIAL').isVisible = false;
            filterWidget.getField('NRSOLICITA').isVisible = false;
        }
    };
    self.gerenciaSolicitaSearch = function (filialField) {
        
        var filterWidget  = filialField.widget;
        var solicitaField = filterWidget.getField('NRSOLICITA');
        
        solicitaField.setValue("");
        
        if (filialField && filialField.value() !== "") {
            solicitaField.dataSourceFilter[0].value = filterWidget.currentRow.CDFILIAL;
            solicitaField.validations = {"required": {}};
            solicitaField.readOnly = false;
            solicitaField.reload();
        } else {
            solicitaField.validations = undefined;
            solicitaField.readOnly = true;
        }
    };

    self.setStripeValues = function (stripeWidget) {
        
        if (!stripeWidget.currentRow.DTPROGENTR) {
            stripeWidget.applyDefaultValue();
        }
        stripeWidget.getField('CDFILIAL').setValue(getLocalVar('CDFILIAL'));
        
        if (stripeWidget.getField('DTPROGENTR').value() === "") {
            var filterWidget = stripeWidget.container.getWidget('cmp03100_solicitacao_FILTER');
            if (!filterWidget.currentRow.START) {
                filterWidget.applyDefaultValue();
            }
            stripeWidget.getField('DTPROGENTR').setValue(filterWidget.currentRow.START);
        } else {
            stripeWidget.getField('DTPROGENTR').setValue(stripeWidget.getField('DTPROGENTR').value().substring(0, 10));
        }
    };

    self.stripeNavigation = function (stripeWidget, widgetToFilter) {
        
        var parentDataSourceFilter = stripeWidget.dataSourceFilter;
        
        parentDataSourceFilter[0].operator  = "=";
        parentDataSourceFilter[0].value     = stripeWidget.currentRow.DTPROGENTR;

        self.setStripeValues(widgetToFilter);
        stripeWidget.dataSourceFilter[0].value = widgetToFilter.currentRow.DTPROGENTR;
        stripeWidget.reload();
    };

    self.openSwipes = function (swipeWidget, parentWidget, stripeWidget) {
        
        var swipeCurrentRow  = swipeWidget.currentRow;
        var stripeCurrentRow = stripeWidget.currentRow;
        var parentCurrentRow = parentWidget.currentRow;

        if (parentCurrentRow.CDFILSOLI === undefined) {
            swipeCurrentRow.CDFILSOLI = stripeCurrentRow.CDFILIAL;
        } else {
            swipeCurrentRow.CDFILSOLI = parentCurrentRow.CDFILSOLI;
        } if (parentCurrentRow.CDFILLAN === undefined) {
            swipeCurrentRow.CDFILLAN = stripeCurrentRow.CDFILIAL;
        } else {
            swipeCurrentRow.CDFILLAN = parentCurrentRow.CDFILLAN;
        } if (parentCurrentRow.CDPRODUTO === undefined) {
            swipeCurrentRow.CDPRODUTO = "";
        } else {
            swipeCurrentRow.CDPRODUTO = parentCurrentRow.CDPRODUTO;
        } if (parentCurrentRow.CDARVPROD === undefined) {
            swipeCurrentRow.CDARVPROD = "";
        } else {
            swipeCurrentRow.CDARVPROD = parentCurrentRow.CDARVPROD;
        } if (parentCurrentRow.NMPRODUTO === undefined) {
            swipeCurrentRow.NMPRODUTO = "";
        } else {
            swipeCurrentRow.NMPRODUTO = parentCurrentRow.NMPRODUTO;
        } if (parentCurrentRow.SGUNIDADE === undefined) {
            swipeCurrentRow.SGUNIDADE = "";
        } else {
            swipeCurrentRow.SGUNIDADE = parentCurrentRow.SGUNIDADE;
        } if (!parentCurrentRow.DTPROGENTR) {
            swipeCurrentRow.DTPROGENTR = "";
            swipeCurrentRow.DTPROGENTR_old = "";
            swipeCurrentRow.DTPROGENTR_compare = "";
        } else {
            swipeCurrentRow.DTPROGENTR_old = parentCurrentRow.DTPROGENTR.substring(0, 10);
            swipeCurrentRow.DTPROGENTR_compare = parentCurrentRow.DTPROGENTR.substring(0, 10);
        }
        swipeWidget.getField('QTSOLIPROD_compare').label =
            swipeWidget.getField('QTSOLIPROD_compare').label.substring(0, 36) + swipeCurrentRow.DTPROGENTR_compare; if (parentCurrentRow.QTSOLIPROD === undefined) {
            swipeCurrentRow.QTSOLIPROD = 0;
            swipeCurrentRow.QTSOLIPROD_compare = 0;
            swipeCurrentRow.QTSOLIPROD_old = 0;
        } else {
            swipeCurrentRow.QTSOLIPROD_old = parentCurrentRow.QTSOLIPROD;
            swipeCurrentRow.QTSOLIPROD_compare = parentCurrentRow.QTSOLIPROD;
            self.comparaItemSoli(swipeWidget);
        } if (parentCurrentRow.IDTIPLAN === undefined) {
            swipeCurrentRow.IDTIPLAN = "NORMAL";
        } else {
            swipeCurrentRow.IDTIPLAN = parentCurrentRow.IDTIPLAN;
        } if (parentCurrentRow.NRSOLICMP === undefined) {
            swipeCurrentRow.NRSOLICMP = "";
        } else {
            swipeCurrentRow.NRSOLICMP = parentCurrentRow.NRSOLICMP;
        } if (parentCurrentRow.DSJUSTOPER === undefined) {
            swipeCurrentRow.DSJUSTOPER = "";
            self.setEditFieldOutra(swipeWidget.getField('DSJUSTOPER'));
        } else {
            swipeCurrentRow.DSJUSTOPER = parentCurrentRow.DSJUSTOPER;
            self.setEditFieldOutra(swipeWidget.getField('DSJUSTOPER'));
            self.isJustificativaAlternativa(swipeWidget.getField('DSJUSTOPER').dataSource.data, swipeWidget);
        } if (parentCurrentRow.CDCOMPRADOR === undefined) {
            swipeCurrentRow.CDCOMPRADOR = null;
            swipeCurrentRow.CDCOMPRADOR_old = null;
        } else {
            swipeCurrentRow.CDCOMPRADOR = parentCurrentRow.CDCOMPRADOR;
            swipeCurrentRow.CDCOMPRADOR_old = parentCurrentRow.CDCOMPRADOR;
        } if (parentCurrentRow.CDDESTSOLI === undefined) {
            swipeCurrentRow.CDDESTSOLI = null;
            swipeCurrentRow.CDDESTSOLI_old = null;
        } else {
            swipeCurrentRow.CDDESTSOLI = parentCurrentRow.CDDESTSOLI;
            swipeCurrentRow.CDDESTSOLI_old = parentCurrentRow.CDDESTSOLI;
        } if (parentCurrentRow.NMCOMPRADOR === undefined) {
            swipeCurrentRow.NMCOMPRADOR = null;
        } else {
            swipeCurrentRow.NMCOMPRADOR = parentCurrentRow.NMCOMPRADOR;
        } if (parentCurrentRow.NMDESTSOLI === undefined) {
            swipeCurrentRow.NMDESTSOLI = null;
        } else {
            swipeCurrentRow.NMDESTSOLI = parentCurrentRow.NMDESTSOLI;
        } if (parentCurrentRow.IDBAIXITMSOL === undefined) {
            swipeCurrentRow.IDBAIXITMSOL = null;
        } else {
            swipeCurrentRow.IDBAIXITMSOL = parentCurrentRow.IDBAIXITMSOL;
        } if (!parentCurrentRow.QTTRANSFSOL) {
            swipeCurrentRow.QTTRANSFSOL = "0";
        } else {
            swipeCurrentRow.QTTRANSFSOL = parentCurrentRow.QTTRANSFSOL;
        } if(parentCurrentRow.DTUTILIZA === undefined){
            swipeCurrentRow.DTUTILIZA = null;
        } else{
            swipeCurrentRow.DTUTILIZA = parentCurrentRow.DTUTILIZA.substring(0, 10);
        } if (habilitaComprador) {
            swipeWidget.getField('NMCOMPRADOR').isVisible = true;
        } else {
            swipeWidget.getField('NMCOMPRADOR').isVisible = false;
        } if (habilitaDestino) {
            swipeWidget.getField('NMDESTSOLI').isVisible = true;
        } else {
            swipeWidget.getField('NMDESTSOLI').isVisible = false;
        } if (habilitaStatus) {
            swipeWidget.getField('IDBAIXITMSOL').isVisible = true;
            swipeWidget.getField('QTTRANSFSOL').isVisible = true;
        } else {
            swipeWidget.getField('IDBAIXITMSOL').isVisible = false;
            swipeWidget.getField('QTTRANSFSOL').isVisible = false;
        } if(gravaDataUtiliza && swipeWidget.getField('DTUTILIZA')){
            swipeWidget.getField('DTUTILIZA').isVisible = true;
        } else {
            if(swipeWidget.getField('DTUTILIZA')) {
                swipeWidget.getField('DTUTILIZA').isVisible = false;
            }
        }

        ScreenService.openSwipe(swipeWidget.getParent());
        swipeWidget.activate();
    };

    self.closeSwipes = function (swipeWidget) {
        swipeWidget.container.getWidget('cmp03100_solicitacao').reload().then(function() {
            ScreenService.closeSwipe();
            swipeWidget.parent.parent.activate();
        });
    };

    self.openEdit = function (widget) {
        
        var editWidget = widget.container.getWidget('cmp03100_solicitacao_edit');
        var stripeWidget = widget.container.getWidget('cmp03100_stripe');
        editWidget.newRow();
        
        self.openSwipes(editWidget, widget, stripeWidget);
        
        if (widget.currentRow.IDTIPLAN.toUpperCase() == 'AUTOMÁTICA' && bloqueiaEditEmSoliAuto) {
            editWidget.getAction('DELETE').isVisible            = false;
            editWidget.getAction('SAVE').isVisible              = false;
            editWidget.getField('QTSOLIPROD').readOnly          = true;
            editWidget.getField('DSJUSTOPER').readOnly          = true;
            editWidget.getField('DSOUTRAJUST').readOnly         = true;
            editWidget.getField('DTPROGENTR_compare').readOnly  = true;
            editWidget.getField('NMCOMPRADOR').readOnly         = true;
            editWidget.getField('NMDESTSOLI').readOnly          = true;
        } else {
            editWidget.getAction('DELETE').isVisible            = true;
            editWidget.getAction('SAVE').isVisible              = true;
            editWidget.getField('QTSOLIPROD').readOnly          = false;
            editWidget.getField('DSJUSTOPER').readOnly          = false;
            editWidget.getField('DTPROGENTR_compare').readOnly  = false;
            editWidget.getField('NMCOMPRADOR').readOnly         = false;
            editWidget.getField('NMDESTSOLI').readOnly          = false;
        }
    };
    self.openAddProdSwipe = function (widget) {
        
        var addProdWidget = widget.container.getWidget('cmp03100_add_prod');
        var stripeWidget = widget.container.getWidget('cmp03100_adiciona_prod_stripe');
        
        self.openSwipes(addProdWidget, widget, stripeWidget);
    };

    self.openAddProd = function () {
        if (hasRegiao === true && isContratoRescindido === false) {
            ScreenService.openWindow("cmp_V1#cmp03100_adiciona_produto").then(function () {
                
                var addProdFilterWidget = templateManager.container.getWidget('cmp03100_add_novo_FILTER');
                var addProdWidget = templateManager.container.getWidget('cmp03100_add_novo');
                
                addProdWidget.dataSource.data = null;
                addProdFilterWidget.getField('PRODINI').setValue("");
                addProdFilterWidget.getField('PRODFIN').setValue("");
                
                if (bloqueiaFiltroPorProdutoCompra) {
                    addProdFilterWidget.getField('IDPRODCOMPRA').isVisible = false;
                }
                
                ScreenService.openSwipe(addProdWidget);
            });
        } else {
            
            if (!hasRegiao && isContratoRescindido) {
                MessageService.showMessageByCode("FILIAL_SEM_REGIAO_CONTRATO_RESCINDIDO");
            } else if (!hasRegiao) {
                MessageService.showMessageByCode("FILIAL_SEM_REGIAO");
            } else {
                MessageService.showMessageByCode("FILIAL_CONTRATO_RESCINDIDO");
            }
        }
    };
    self.fechaAddProd = function () {
        ScreenService.openWindow("cmp_V1#cmp03100_solicitacao_de_compras");
    };

    self.isJustificativaAlternativa = function (justificativasData, widget) {
        
        var isJustificativaAlternativa = true;
        var dsJustOperField = widget.getField('DSJUSTOPER');
        var dsOutraJustField = widget.getField('DSOUTRAJUST');
        var dsJustOperFieldLength = 0;

        if(dsJustOperField.value()){
            dsJustOperFieldLength = dsJustOperField.value().length;
        }

        for (i = 0; i < justificativasData.length; i++) {
            if (widget.currentRow.DSJUSTOPER == justificativasData[i].DSJUSTSOL) {
                isJustificativaAlternativa = false;
            }
        }
        
        if (isJustificativaAlternativa && dsJustOperFieldLength > 0) {
            dsOutraJustField.setValue(widget.currentRow.DSJUSTOPER);
            dsJustOperField.setValue("OUTRA");
            dsOutraJustField.readOnly = false;
        } else {
            dsOutraJustField.readOnly = true;
        }

        self.setJustificaValidation(widget);
    };

    self.hasOpcaoOutra = function (field) {
        
        var dados = field.dataSource.data;
        var flagExisteOutra = false;
        
        for (i = 0; i < dados.length; i++) {
            if (dados[i].DSJUSTSOL.toUpperCase() == "OUTRA") {
                flagExisteOutra = true;
            }
        }
        
        if (flagExisteOutra === false) {
            self.addOpcaoOutra(dados);
        }
    };

    self.addOpcaoOutra = function (dados) {
        dados.push({"DSJUSTSOL": "OUTRA"});
    };

    self.setEditFieldOutra = function (field) {
        
        field.widget.getField('DSOUTRAJUST').setValue("");
        var justificativa = field.value();

        if(justificativa){
            justificativa = justificativa.toUpperCase();
        } if (justificativa == "OUTRA") {
            field.widget.getField('DSOUTRAJUST').readOnly = false;
        } else {
            field.widget.getField('DSOUTRAJUST').readOnly = true;
        }

        self.setJustificaValidation(field.widget);
    };
    self.setJustificaValidation = function (swipeWidget) {
        
        var dsJustOperField = swipeWidget.getField('DSJUSTOPER');
        var dsOutraJustField = swipeWidget.getField('DSOUTRAJUST');
        var swipeCurrentRow = swipeWidget.currentRow;
        var dsJustOperFieldUpper = dsJustOperField.value();

        if(dsJustOperFieldUpper){
            dsJustOperFieldUpper = dsJustOperFieldUpper.toUpperCase();
        } if ((swipeCurrentRow.IDTIPLAN.toUpperCase() == 'EXTRA' || swipeCurrentRow.IDTIPLAN.toUpperCase() == 'MANUAL EXTRA') && isJutificativaExtraObrigatoria) {
            dsJustOperField.validations = {"required": {}};

            if (dsJustOperFieldUpper == "OUTRA") {
                dsOutraJustField.validations = {"required": {}};
            } else {
                dsOutraJustField.validations = undefined;
            }
        } else {
            
            if (isJustificativaObrigatoria) {
                dsJustOperField.validations = {"required": {}};

                if (dsJustOperFieldUpper == "OUTRA") {
                    dsOutraJustField.validations = {"required": {}};
                } else {
                    dsOutraJustField.validations = undefined;
                }
            } else {
                dsJustOperField.validations = undefined;
                dsOutraJustField.validations = undefined;
            }
        }
    };

    self.saveProds = function (swipeWidget) {
        var rotinaSalvamento = function (swipeWidget) {
            if (swipeWidget.isValid()) {
                var swipeCurrentRow = swipeWidget.currentRow;
                if (self.quantidadePositiva(swipeCurrentRow.QTSOLIPROD)) {
                    var dsJustOperUpper = swipeCurrentRow.DSJUSTOPER;
                    if(dsJustOperUpper){
                        dsJustOperUpper = dsJustOperUpper.toUpperCase();
                    } if (dsJustOperUpper == "OUTRA") {
                        swipeCurrentRow.DSJUSTOPER = swipeCurrentRow.DSOUTRAJUST;
                        swipeCurrentRow.DSOUTRAJUST = "";
                    } if (gravaDataUtiliza) {
                        swipeCurrentRow.DTUTILIZA = swipeCurrentRow.DTPROGENTR;
                    } else {
                        swipeCurrentRow.DTUTILIZA = null;
                    } if (!habilitaComprador || !swipeCurrentRow.CDCOMPRADOR) {
                        swipeCurrentRow.CDCOMPRADOR = null;
                    } if (!habilitaDestino || !swipeCurrentRow.CDDESTINO) {
                        swipeCurrentRow.CDDESTINO = null;
                    }
                    swipeCurrentRow.CDOPERLANC = getLocalVar('CDOPERADOR');
                    if(typeof swipeCurrentRow.QTSOLIPROD == "string"){
                        swipeCurrentRow.QTSOLIPROD = parseFloat(swipeCurrentRow.QTSOLIPROD.replace(/\./g, '').replace(',', '.'));
                    }
                    SolicitacaoComprasService.save(swipeCurrentRow).then(function () {
                        //swipeWidget.parent.parent.reload();
                        self.atualizaStripeData();
                        self.closeSwipes(swipeWidget);
                    });
                } else {
                    MessageService.showMessageByCode("QTDFINAL_MAIOR_ZERO");
                }
            } else {
                MessageService.showMessageByCode("TODOS_CAMPOS_OBRIGATORIOS");
            }
        };
        if (verificarPeriodicidade && (swipeWidget.currentRow.IDTIPLAN.toUpperCase() == 'MANUAL' ||
            
            swipeWidget.currentRow.IDTIPLAN.toUpperCase() == 'AUTOMÁTICA' ||
            swipeWidget.currentRow.IDTIPLAN.toUpperCase() == 'NORMAL')) {
            self.existePeriodicidade(swipeWidget.currentRow).then(function (existePeriodicidadeFlag) {
            
                if(!existePeriodicidadeFlag) {
                    MessageService.showMessageByCode("PROD_SEM_PERIODICIDADE_ENTREGA");
                } else {
                    rotinaSalvamento(swipeWidget);
                }
            });
        } else {
            rotinaSalvamento(swipeWidget);
        }
    };

    self.deleteItemSoli = function (swipeWidget) {
        SolicitacaoComprasService.delete(swipeWidget.currentRow).then(function () {
            swipeWidget.parent.parent.reload();
            ScreenService.closeSwipe();
        });
    };

    self.deleteMuitos = function (parentWidget) {
        
        var rowsToDelete = parentWidget.getCheckedRows();
        
        for (i = 0; i < rowsToDelete.length - 1; i++) {
            rowsToDelete[i].DTPROGENTR_old = rowsToDelete[i].DTPROGENTR;
            SolicitacaoComprasService.delete(rowsToDelete[i]);
        }
        
        rowsToDelete[i].DTPROGENTR_old = rowsToDelete[i].DTPROGENTR;
        
        SolicitacaoComprasService.delete(rowsToDelete[i]).then(function () {
            parentWidget.reload();
        });
    };

    self.comparaItemSoli = function (swipeWidget) {
        
        var row = swipeWidget.currentRow;
        
        row.DTPROGENTR = row.DTPROGENTR_compare;
        swipeWidget.getField('QTSOLIPROD_compare').label = swipeWidget.getField('QTSOLIPROD_compare').label.substring(0, 36) + row.DTPROGENTR_compare;
        
        if (row.QTSOLIPROD_old.length === 0) {
            row.QTSOLIPROD_old = 0;
        }
        if (row.DTPROGENTR_old == row.DTPROGENTR_compare && row.CDDESTSOLI_old == row.CDDESTSOLI && row.CDDESTSOLI_old == row.CDDESTSOLI) {
            row.QTSOLIPROD = row.QTSOLIPROD_old;
            row.QTSOLIPROD_compare = row.QTSOLIPROD_old;
            
            if (swipeWidget.getAction('DELETE') !== undefined) {
                swipeWidget.getAction('DELETE').isVisible = true;
            }
        } else {
            var filterArray = [];
            
            filterArray.CDFILLAN = row.CDFILLAN;
            filterArray.DTPROGENTR = row.DTPROGENTR;
            filterArray.CDPRODUTO = row.CDPRODUTO;
            filterArray.CDDESTSOLI = row.CDDESTSOLI;
            filterArray.CDCOMPRADOR = row.CDCOMPRADOR;
            
            if (row.IDTIPLAN.toUpperCase() == 'EXTRA' || row.IDTIPLAN.toUpperCase() == 'MANUAL EXTRA') {
                filterArray.IDTIPLAN = 'MANUAL EXTRA';
            } else {
                filterArray.IDTIPLAN = 'MANUAL';
            }
            
            SolicitacaoComprasService.getItemSoli(filterArray).then(function (callback) {
                var produtoExistente = callback.dataset.solicitacao_compras_justificativa[0];
                
                if (!produtoExistente) {
                    row.QTSOLIPROD_compare  = 0;
                    //row.QTSOLIPROD          = row.QTSOLIPROD_old;
                } else {
                    row.QTSOLIPROD_compare  = produtoExistente.QTSOLIPROD;
                    //row.QTSOLIPROD          = parseFloat(row.QTSOLIPROD_compare) + parseFloat(row.QTSOLIPROD_old);
                }
            });
            if (swipeWidget.getAction('DELETE') !== undefined) {
                swipeWidget.getAction('DELETE').isVisible = false;
            }
        }
        self.setJustificaValidation(swipeWidget);
    };
    self.desativaEdicao = function (tipoSoliField) {
        
        var widget = tipoSoliField.widget;
        
        if (tipoSoliField.value().length === 0) {
            widget.getField('DTPROGENTR_compare').readOnly = true;
            widget.getField('QTSOLIPROD').readOnly         = true;
        } else {
            widget.getField('DTPROGENTR_compare').readOnly = false;
            widget.getField('QTSOLIPROD').readOnly         = false;

            self.comparaItemSoli(widget);
        }
    };

    self.verificaData = function (dataField) {
        
        var data = dataField.value();
        
        data = data.split("/");
        data = data[1] + "," + data[0] + "," + data[2];

        Parametros.retornaDataProcessamento().then(function (callback) {
            var dataProcessamento   = callback;
            dataProcessamento       = dataProcessamento.split("/");
            dataProcessamento       = dataProcessamento[1] + "," + dataProcessamento[0] + "," + dataProcessamento[2];
            
            if (Date.parse(data) < Date.parse(dataProcessamento)) {
                dataField.setValue(callback.substring(0, 10));
                MessageService.showMessageByCode("DTA_INICIAL_MENOR_IGUAL_DTA_FINAL");
            } else {
                self.comparaItemSoli(dataField.widget);
            }
        });
    };

    self.getUnique = function (value, index, self) {
        return self.indexOf(value) === index;
    };

    self.existePeriodicidade = function (currentRow) {
        var filterArray = [];
        filterArray.DTPROGENTR = currentRow.DTPROGENTR;
        filterArray.CDPRODUTO = currentRow.CDPRODUTO;
        return SolicitacaoComprasService.getPeriodicidade(filterArray).then(function (callback) {
            if(callback.dataset.periodicidade.length === 0) {
                return false;
            } else {
                return true;
            }
        });
    };
    self.quantidadePositiva = function (quantidade){
        var tipo = typeof quantidade;

        if(tipo == 'string'){
            quantidade = parseFloat(quantidade.replace(/\./g, '').replace(',', '.'));
        } else{
            quantidade = parseFloat(quantidade);
        } if(quantidade <= 0){
            return false;
        } else{
            return true;
        }
    };

    self.atualizaStripeData = function(){
        if(!stripeWidgetFilter.length){
            stripeWidgetFilter.push(
                {
                    "name": "DTPROGENTR",
                    "value": moment().format('DD/MM/YYYY'),
                    "operator": "="
                }
            );
        }
        stripeWidget.dataSourceFilter = angular.copy(stripeWidgetFilter);
        stripeWidget.reload().then(function(){
            var dados = stripeWidget.dataSource.data;

            if (dados.length > 0) {
                var todasDatas      = [];
                var dadosFiltrados  = [];

                for (i = 0; i < dados.length; i++) {
                    todasDatas.push(dados[i].DTPROGENTR.substring(0, 10));
                }
                var distinctDatas = todasDatas.filter(self.getUnique);

                for (i = 0; i < distinctDatas.length; i++) {
                    dadosFiltrados.push({"DTPROGENTR": distinctDatas[i]});
                }

                stripeWidget.dataSource.data = dadosFiltrados;
                stripeWidget.moveToFirst();
            }
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('SolicitacaoComprasController', SolicitacaoComprasController);
});